<template>
  <Container class="h-full">
    <section class="flex items-center justify-between gap-2">
      <SectionHeader icon="mdi-sale-outline">
        Коррекции
      </SectionHeader>

      <v-scroll-y-transition>
        <v-btn
          v-if="[BookingStatus.BOOKED, BookingStatus.ACTIVE].includes(booking.status)"
          variant="tonal"
          class="text-amber-600 flex-initial"
          size="small"
          icon="mdi-pencil"
          @click="isEditShown = true"
        />
      </v-scroll-y-transition>
    </section>

    <section
      v-if="!booking.corrections.length"
      class="flex-auto mt-2"
    >
      <EmptyState
        class="bg-gray-100 py-6"
        embedded
      />
    </section>

    <v-list
      v-else
      lines="two"
    >
      <v-list-item
        v-for="(correction, index) in booking.corrections"
        :key="correction.id"
        class="[&_.v-list-item-title]:whitespace-normal"
        :class="{ 'bg-gray-100': index % 2 === 0 }"
      >
        <template #prepend>
          <v-icon icon="mdi-text-short" />
        </template>

        <template #title>
          {{ correction.reason }}
        </template>

        <template #subtitle>
          <ProfitDisplay
            mode="plain"
            :value="correction.value"
          />
        </template>
      </v-list-item>
    </v-list>
  </Container>

  <v-dialog
    v-model="isEditShown"
    persistent
  >
    <FloatingContainer>
      <FormHeader
        icon="mdi-pencil-outline"
        headline="Изменение коррекций"
        subtitle="Прибыль от бронирования будет пересчитана"
      />

      <section class="pt-4">
        <FormRow label="Добавьте коррекции">
          <section class="min-w-full w-min mt-2">
            <CorrectionsSelection v-model="updatedCorrections" />
          </section>
        </FormRow>

        <FormRow spacing="large">
          <v-btn
            block
            rounded
            size="large"
            class="text-white font-bold bg-gradient-to-r from-teal-400 to-cyan-500"
            @click="onCorrectionsUpdate"
          >
            Изменить
          </v-btn>
        </FormRow>

        <FormRow>
          <v-btn
            block
            rounded
            size="small"
            variant="plain"
            :ripple="false"
            class="font-bold"
            @click="onCorrectionsUpdateCancel"
          >
            Отмена
          </v-btn>
        </FormRow>
      </section>
    </FloatingContainer>
  </v-dialog>
</template>

<script setup lang="ts">
import { ref, watch } from 'vue';

import { BookingStatus } from '@/declarations';
import { sleep } from '@/utils';

import Container from '@/components/layout/Container.vue';
import ProfitDisplay from '@/components/content/ProfitDisplay.vue';
import EmptyState from '@/components/layout/EmptyState.vue';

import SectionHeader from '@/components/layout/SectionHeader.vue';
import FormHeader from '@/components/layout/FormHeader.vue';
import FormRow from '@/components/layout/FormRow.vue';
import FloatingContainer from '@/components/layout/FloatingContainer.vue';

import CorrectionsSelection from '../create/corrections/CorrectionsSelection.vue';

const props = defineProps<{ booking: IVerboseBooking }>();
const emit = defineEmits(['update:corrections']);

const getCorrectionsClone = () => {
  return props.booking.corrections.map(correction => ({ ...correction }));
};

const isEditShown = ref(false);
const updatedCorrections = ref(getCorrectionsClone());

const onCorrectionsUpdate = async () => {
  /**
   * This sleep needed when user clicks on Update button while
   * correction is focused i.e. editing
   *
   * Give a chance for v-model to update before emitting event
   * using its value. Crutch? Seems so, but it's better to let
   * it work somehow right now, instead of spending hours to debug
   */
  await sleep(100);

  emit('update:corrections', updatedCorrections.value);
  isEditShown.value = false;
};

const onCorrectionsUpdateCancel = () => {
  updatedCorrections.value = getCorrectionsClone();
  isEditShown.value = false;
};

watch(isEditShown, (isShown) => {
  if (isShown) {
    updatedCorrections.value = getCorrectionsClone();
  }
});
</script>